@tool
extends Area3D

@export var generate: bool = false: get = _get_generate, set = _set_generate
@export var distance: Vector3 = Vector3(1, 1, 1)

func _set_generate(value: bool):
	generate = value
	
	if value:
		_generate_probes()
	else:
		_remove_probes()

func _get_generate():
	return generate

func _remove_probes():
	for node in $CollisionShape3D.get_children(true):	
		$CollisionShape3D.remove_child(node)

func _generate_probes():
	var size : Vector3 = $CollisionShape3D.shape.size	
	var initial_position = -(size / 2)
	var current_position = initial_position
	var maxX = current_position.x + size.x
	var maxY = current_position.y + size.y
	var maxZ = current_position.z + size.z	
		
	while (current_position.x < maxX):
		while (current_position.y < maxY):
			while (current_position.z < maxZ):
				add_probe(current_position)
				current_position.z += distance.z
			current_position.y += distance.y
			current_position.z = initial_position.z
		current_position.x += distance.x
		current_position.y = initial_position.y

func add_probe(position: Vector3):	
	var probe : LightmapProbe = LightmapProbe.new()
	$CollisionShape3D.add_child(probe, false, Node.INTERNAL_MODE_BACK)
	probe.set_owner(get_tree().get_edited_scene_root())
	probe.position = position
